clear


%% 闭合曲线wrapping 控制点
ctrlpoints=[0,6,4,-12,-6,10,30,26,36,32,0,6,4;
    0,5,15,20,40,44,35,18,10,6,0,5,15];
knots = [0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16];

% % 
%% 开曲线
% ctrlpoints=[0,6,4,-12,-6,10,30,26,36,32;
%     0,5,15,20,40,44,35,18,10,6];
% knots=[1 5 9 12 15 22 28 31 35 44 49 55 59 66]; % open

% % n+1=10

% %% clamped曲线
% ctrlpoints=[0,6,4,-12,-6,10,30,26,36,32;
%     0,5,15,20,40,44,35,18,10,6];
% knots=[0 0 0 1 2 3 4 5 6 7 8 8 8];% clamped


% % m+1=14    m=p+n+1 p =3  up ~ un-p

m = length(knots)-1;
n = size(ctrlpoints,2)-1;
pp = m-n-1;
p = spmak(knots,ctrlpoints);%生成B样条函数

t = linspace(knots(pp+1),knots(m+1-pp),10000);
dp = fnder(p);
ddp = fnder(dp);

Xd = fnval(p, t);
Vd = fnval(dp, t);
Ad = fnval(ddp, t);

xt = Xd(1,:);
yt = Xd(2,:);

figure(1)

% plot(ctrlpoints(1,:),ctrlpoints(2,:),'color',[0.3010 0.7450 0.9330],'linewidth',3);
plot(ctrlpoints(1,:),ctrlpoints(2,:),'color','k','linewidth',1);
hold on 
for i = 1:n+1
    hold on
%     plot(ctrlpoints(1,i),ctrlpoints(2,i),'.','color',[0 0.4470 0.7410],'MarkerSize',30);
    plot(ctrlpoints(1,i),ctrlpoints(2,i),'.','color','k','MarkerSize',30);
end
% plot(xt,yt,'color',[0.8500 0.3250 0.0980],'linewidth',3);
plot(xt,yt,'color','k','linewidth',3);
xlabel("x/米")
ylabel("y/米")
set(gca,'Fontsize',14)
axis('equal')
