clear
points = [0 30 50 90 125 150 180 200 260 270;
        0 3 3 0 -3 -3 0 3.5 2.8 0];

[x, y, t] = bezir_n(points);

dy = diff(y,t);
dx = diff(x,t);
ddy = diff(dy,t);
ddx = diff(dx,t);
dddy = diff(ddy,t);
dddx = diff(ddx,t);

fx = matlabFunction(x);
fy = matlabFunction(y);

dfx = matlabFunction(dx);
dfy = matlabFunction(dy);

ddfx = matlabFunction(ddx);
ddfy = matlabFunction(ddy);

dddfx = matlabFunction(dddx);
dddfy = matlabFunction(dddy);

stoptime = 20;
time_step = 0.1;

tt = 0:time_step:stoptime;
xt = fx(tt/stoptime);
yt = fy(tt/stoptime);
dxt = dfx(tt/stoptime)/stoptime;
dyt = dfy(tt/stoptime)/stoptime;
ddxt = ddfx(tt/stoptime)/stoptime/stoptime;
ddyt = ddfy(tt/stoptime)/stoptime/stoptime;
dddxt = dddfx(tt/stoptime)/stoptime/stoptime/stoptime;
dddyt = dddfy(tt/stoptime)/stoptime/stoptime/stoptime;


figure(1)
plot(xt,yt,LineWidth=3,Color='k')

n = size(points,2);

hold on
for i = 1:n
    plot(points(1,i),points(2,i),'.','MarkerSize',40,Color='k');
end
for i = 1:n-1
    plot([points(1,i),points(1,i+1)],[points(2,i),points(2,i+1)],Color='k');
end
xlabel("x (m)","FontSize",16,'FontName',"times new roman")
ylabel("y (m)","FontSize",16,'FontName',"times new roman")
set(gca,"FontSize",16,'FontName',"times new roman")
xlim([points(1,1),points(1,end)])


