figure(1)
cla;
hold on
for i = 1: size(obs, 1)
    rectangle('Position', [obs(i,1)-obs(i,3), -obs(i,2)-obs(i,3), obs(i,3) * 2, obs(i,3) * 2], 'Curvature', [1 1], 'Facecolor', [0,0,0]);
end
plot(xd,-yd,'--',LineWidth=2,Color='k')
plot(X(:,1),X(:,2),LineWidth=2,Color='k')
legend("期望轨迹","实际轨迹")
xlabel("X/m")
ylabel("Y/m")
set(gca,'Fontsize',14)

w1 = 1.5;
w2 = 1.5;
figure(2)
len = size(Xd,1);
t = stoptime/len:stoptime/len:stoptime;

subplot(211)
plot(t, Xd(:,1),LineWidth=w1,Color='k',LineStyle='--')
hold on 
plot(t, X(:,1),LineWidth=w2,Color='k')
legend("期望位置(北)","实际位置(北)")
xlabel("时间/秒")
ylabel("长度/米")

subplot(212)
plot(t, Xd(:,2),LineWidth=w1,Color='k',LineStyle='--')
hold on 
plot(t, X(:,2),LineWidth=w2,Color='k')
legend("期望位置(东)","实际位置(东)")
xlabel("时间/秒")
ylabel("长度/米")


figure(3)

subplot(211)
plot(t, Vd(:,1),LineWidth=w1,Color='k',LineStyle='--')
hold on 
plot(t, V(:,1),LineWidth=w2,Color='k')
legend("期望速度(北)","实际速度(北)")
xlabel("时间/秒")
ylabel("速度/米每秒")

subplot(212)
plot(t, Vd(:,2),LineWidth=w1,Color='k',LineStyle='--')
hold on 
plot(t, V(:,2),LineWidth=w2,Color='k')
legend("期望速度(东)","实际速度(东)")
xlabel("时间/s")
ylabel("速度/米每秒")


figure(4)

subplot(211)
plot(t, Ad(:,1),LineWidth=w1,Color='k',LineStyle='--')
hold on 
plot(t, A(:,1),LineWidth=w2,Color='k')
legend("期望加速度(北)","实际加速度(北)")
xlabel("时间/秒")
ylabel("加速度")

subplot(212)
plot(t, Ad(:,2),LineWidth=w1,Color='k',LineStyle='--')
hold on 
plot(t, A(:,2),LineWidth=w2,Color='k')
legend("期望加速度(东)","实际加速度(东)")
xlabel("时间/秒")
ylabel("加速度")
